    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ---------------------
    028 * TimePeriodAnchor.java
    029 * ---------------------
    030 * (C) Copyright 2003-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 30-Jul-2003 : Version 1 (DG);
    038 * 01-Mar-2004 : Added readResolve() method (DG);
    039 *
    040 */
    041
    042package org.jfree.data.time;
    043
    044import java.io.ObjectStreamException;
    045import java.io.Serializable;
    046
    047/**
    048 * Used to indicate one of three positions in a time period:
    049 * <code>START</code>, <code>MIDDLE</code> and <code>END</code>.
    050 */
    051public final class TimePeriodAnchor implements Serializable {
    052
    053    /** For serialization. */
    054    private static final long serialVersionUID = 2011955697457548862L;
    055
    056    /** Start of period. */
    057    public static final TimePeriodAnchor START
    058        = new TimePeriodAnchor("TimePeriodAnchor.START");
    059
    060    /** Middle of period. */
    061    public static final TimePeriodAnchor MIDDLE
    062        = new TimePeriodAnchor("TimePeriodAnchor.MIDDLE");
    063
    064    /** End of period. */
    065    public static final TimePeriodAnchor END
    066        = new TimePeriodAnchor("TimePeriodAnchor.END");
    067
    068    /** The name. */
    069    private String name;
    070
    071    /**
    072     * Private constructor.
    073     *
    074     * @param name  the name.
    075     */
    076    private TimePeriodAnchor(String name) {
    077        this.name = name;
    078    }
    079
    080    /**
    081     * Returns a string representing the object.
    082     *
    083     * @return The string.
    084     */
    085    public String toString() {
    086        return this.name;
    087    }
    088
    089    /**
    090     * Returns <code>true</code> if this object is equal to the specified
    091     * object, and <code>false</code> otherwise.
    092     *
    093     * @param obj  the other object.
    094     *
    095     * @return A boolean.
    096     */
    097    public boolean equals(Object obj) {
    098
    099        if (this == obj) {
    100            return true;
    101        }
    102        if (!(obj instanceof TimePeriodAnchor)) {
    103            return false;
    104        }
    105
    106        TimePeriodAnchor position = (TimePeriodAnchor) obj;
    107        if (!this.name.equals(position.name)) {
    108            return false;
    109        }
    110
    111        return true;
    112    }
    113
    114    /**
    115     * Returns a hash code value for the object.
    116     *
    117     * @return The hashcode
    118     */
    119    public int hashCode() {
    120        return this.name.hashCode();
    121    }
    122
    123    /**
    124     * Ensures that serialization returns the unique instances.
    125     *
    126     * @return The object.
    127     *
    128     * @throws ObjectStreamException if there is a problem.
    129     */
    130    private Object readResolve() throws ObjectStreamException {
    131        if (this.equals(TimePeriodAnchor.START)) {
    132            return TimePeriodAnchor.START;
    133        }
    134        else if (this.equals(TimePeriodAnchor.MIDDLE)) {
    135            return TimePeriodAnchor.MIDDLE;
    136        }
    137        else if (this.equals(TimePeriodAnchor.END)) {
    138            return TimePeriodAnchor.END;
    139        }
    140        return null;
    141    }
    142
    143}